# babel plugin开发
  只要是用过es6开发过的，一定都接触过babel，那什么是babel呢？用官方的话说是The compiler for writing next generation JavaScript.<br/>
 nice，它是一个支持es6的js代码编译器，底层实现了ast语法树。我想这是一个非常让人兴奋的工具，绝不仅仅是因为它能让我们写es6的代码，而是它已插件的形式提供了让我们去**操控js源码的能力**，这里我提供两个链接供大家学习
  [AST抽象语法树](https://github.com/babel/babylon/blob/master/ast/spec.md)
  [babel插件API](https://github.com/thejameskyle/babel-handbook/blob/master/translations/en/plugin-handbook.md)

# .babelrc
  我们在使用babel的时候，一定少不了.babelrc(最常用，还有其他形式如package.json中的babel)
```javascript
{
  "presets": [],
  "plugins" :[]
}

```
以上就是.babelrc的基本形式，而我们要开发的插件对应的就是plugins了，presets是预设，也是用来配置Plugins的~~

# plugin开发
  我们先看看插件的基本骨架
```javascript
'use strict'


export default ({types:t})=>{
  return {
    visitor:{
    }
  }
}
```
  两个比较重要的变量,types,visitor
  types: 提供针对AST操作的接口
  visitor:提供


# babel-plugin-react-visualizer
  babel-plugin-react-visualizer 让react的组件变得可视化<br/>
  一旦react组件的render被触发了，组件就会闪烁，有了它可以让我们实时掌控页面的渲染状态，<br/>也方便我们对页面进行调优

# Getting started
install babel-plugin-react-visualizer with npm
```javascript
npm install babel-plugin-react-visualizer -D
```

then add 'react-visualizer' into .babelrc
```json
{
  "presets":[],
  "plugins":[],
  "env":{
    "development":{
      "plugins":[
        "react-visualizer"
      ]
    }
  }
} 
```
finally just enjoy it!!
