'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

require('./index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SHOW_CLASSNAME = 'luo-react-render-effect';

function addClassName(dom, clz) {
  dom.className += clz;
}

function removeClassName(dom, clz) {
  var clzArr = dom.className.split(/\s+/);
  clzArr.push(clz);
  dom.className = clzArr.join(' ');
}

exports.default = function (ComposedComponent) {
  var PureRenderComponent = function (_React$Component) {
    _inherits(PureRenderComponent, _React$Component);

    function PureRenderComponent(props) {
      _classCallCheck(this, PureRenderComponent);

      var _this = _possibleConstructorReturn(this, (PureRenderComponent.__proto__ || Object.getPrototypeOf(PureRenderComponent)).call(this, props));

      _this.shouldComponentUpdate = ComposedComponent.shouldComponentUpdate;
      return _this;
    }

    _createClass(PureRenderComponent, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var dom = _reactDom2.default.findDOMNode(this);
        if (dom) {
          this.webkitAnimationEnd = dom.addEventListener("animationend webkitAnimationEnd", function () {
            //动画结束时事件 
            removeClassName(this, SHOW_CLASSNAME);
          }, false);
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var dom = _reactDom2.default.findDOMNode(this);
        if (dom) {
          dom.removeEventListener("animationend webkitAnimationEnd", this.webkitAnimationEnd);
        }
        this.webkitAnimationEnd = null;
      }
    }, {
      key: 'componentWillUpdate',
      value: function componentWillUpdate() {
        var dom = _reactDom2.default.findDOMNode(this);
        if (dom) {
          addClassName(dom, SHOW_CLASSNAME);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(ComposedComponent, _extends({}, this.props, this.state));
      }
    }]);

    return PureRenderComponent;
  }(_react2.default.Component);

  return Object.assign(PureRenderComponent, ComposedComponent);
};